#include <iostream>
#include <stdlib.h>
#include <stdio.h>
using namespace std;
#define MAXN 1000000
int v[MAXN+25];
int main()
{
    int n,k,i,j,val1=0,val2=0,val3=0,val4=0,ind1,ind2,ind3,x,max=-1;
    scanf("%d%d",&n,&k);
    for(i=1 ; i<=n ; i++){
        scanf("%d",&v[i]);
    }
    if(k==1){
        for(i=1 ; i<=n ; i++){
            val1|=v[i];
        }
        printf("%d",val1);
    }
    if(k==2){
        for(ind1=1 ; ind1<=n ; ind1++){
            val1=0;
            val1=v[1];
            for(i=2 ; i<ind1 ; i++){
                val1|=v[i];
            }
            val2=v[ind1];
            for(i=ind1+1 ; i<=n ; i++){
                val2|=v[i];
            }
            x=val1&val2;
            if(x>max){
                max=x;
            }
        }
        printf("%d",max);
    }
    if(k==3){
        for(ind1=2 ; ind1<n ; ind1++){
            for(ind2=ind1+1 ; ind2<n ; ind2++){
                val1=val2=val3=0;
                for(i=1 ; i<ind1 ; i++){
                    val1|=v[i];
                }
                for(i=ind1 ; i<ind2 ; i++){
                    val2|=v[i];
                }
                for(i=ind2 ; i<=n ; i++){
                    val3|=v[i];
                }
                x=val1&val2&val3;
                if(x>max){
                    max=x;
                }
            }
        }
        printf("%d",max);
    }
    if(k==4){
        for(ind1=1 ; ind1<n ; ind1++){
            for(ind2=ind1+1 ; ind2<n ; ind2++){
                for(ind3=ind2+1 ; ind3<n ; ind3++){
                    val1=val2=val3=val4=0;
                    for(i=1 ; i<ind1 ; i++){
                        val1|=v[i];
                    }
                    for(i=ind1 ; i<ind2 ; i++){
                        val2|=v[i];
                    }
                    for(i=ind2 ; i<ind3 ; i++){
                        val3|=v[i];
                    }
                    for(i=ind3 ; i<=n ; i++){
                        val4|=v[i];
                    }
                    x=val1&val2&val3&val4;
                    if(x>max){
                        max=x;
                    }
                }
            }
        }
        printf("%d",max);
    }
    return 0;
}
